<script>
    // Imports
    import { arc, radialArea } from "d3-shape";
    import { scaleLinear, scaleRadial } from "d3-scale";
    import { extent } from "d3-array";

    // Global variables
    export let data = [];
    export let city;

    // Environment
      // Size and margins
    const width = 600;
    const height = 250;
    const margin = { top: 10, right: 10, bottom: 10, left: 10 };
    const innerWidth = width - margin.left - margin.right;
    const innerHeight = height - margin.top - margin.bottom;

    // Local variables
    let maxRadius = 50;
    let whitespace = 5;

    // Data Manipulation
    data = data.filter(d => d.city == city);

    /*
    $: for (let d of data) {
        // console.log(xScale(d.day_of_year));
        console.log(yScaleHeating(d.heating));
    }
    */


    // Scales

    const xScale = scaleLinear()
        // scaleBand() maybe?
        // scaleLinear() maybe?
        .range([0, 2 * Math.PI])
        .domain(extent(data, d => d.day_of_year))

    
    const yScaleHeating = scaleRadial()
        .range([0, maxRadius])
        .domain(extent(data, d => d.heating))
    
    const yScaleCooling = scaleRadial()
        .range([0, maxRadius])
        .domain(extent(data, d => d.cooling))


    // Areas

    const areaCooling = radialArea()
        .angle(d => xScale(d.day_of_year))
        .innerRadius(0)
        .outerRadius(d => yScaleCooling(d.cooling))

    const areaHeating = radialArea()
        .angle(d => xScale(d.day_of_year))
        .innerRadius(0)
        .outerRadius(d => yScaleHeating(d.heating))

</script>
<svg viewBox="0 0 {width/3} {height}" style="max-width: {width/3}px">
    <g transform="translate({margin.left}, {margin.top})">
        <g transform="translate(0,25)">
            <text class="title" x="50%" text-anchor="middle">{city} <br/></text>
        </g>
        <g transform="translate({width/6},125)">
            <circle cx=0 cy=0 r={maxRadius + whitespace} fill="#66000000" fill-opacity=1 stroke="black"/> 
            <line x1=0 y1={-(maxRadius+whitespace)} x2=0 y2={maxRadius+whitespace} stroke="black" stroke-width=1/>
            <line x1={-(maxRadius+whitespace)} y1=0 x2={maxRadius+whitespace} y2=0 stroke="black" stroke-width=1/>
            <path d={areaCooling(data)} fill="blue" stroke="blue" fill-opacity=0.5 stroke-opacity=0.8/>
            <path d={areaHeating(data)} fill="red" stroke="red" fill-opacity=0.5 stroke-opacity=0.8/>
            <text class="legend" transform="translate(0,{-(maxRadius+whitespace+10)})">0</text>
            <text class="legend" transform="translate({(maxRadius+whitespace+8)},0)">3</text>
            <text class="legend" transform="translate(0,{(maxRadius+whitespace+10)})">6</text>
            <text class="legend" transform="translate({-(maxRadius+whitespace+8)},0)">9</text>
        </g>
    </g>
</svg>

<style>
    .title{
        font: italic 20px serif;
    }
    text.legend{
        text-anchor: middle;
        dominant-baseline: middle;
        font: 15px serif;
    }
</style>
